/* A servlet to display the contents of the PostgreSQL mydatabasename database */

import java.io.*;
import java.sql.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class Electrodomestics extends HttpServlet
{
    public String getServletInfo() {
       return "Servlet connects to PostgreSQL database and displays result of a SELECT";
    }

    private Connection dbcon;  // Connection

    // "init" sets up a database connection
    public void init(ServletConfig config) throws ServletException {
        String loginUser = "postgres";
        String loginPasswd = "SQL";
        String loginUrl = "jdbc:postgresql://localhost:5432/electrodomestics";

        // Load the PostgreSQL driver
        try {
            Class.forName("org.postgresql.Driver");
            dbcon = DriverManager.getConnection(loginUrl, loginUser, loginPasswd);
        } catch (ClassNotFoundException ex) {
            System.err.println("ClassNotFoundException: " + ex.getMessage());
            throw new ServletException("Class not found Error");
        } catch (SQLException ex) {
            System.err.println("SQLException: " + ex.getMessage());
        }
    }

    // Use http GET
    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws IOException, ServletException {
        response.setContentType("text/html");    // Response mime type

        // Output stream to STDOUT
        PrintWriter out = response.getWriter();

        out.println("<HTML><Head><Title>Electrodomstics</Title></Head>");

        try {
            String CONSULTA = request.getParameter("consulta");
            if (CONSULTA != null) {

               // Declare our statement
               Statement statement = dbcon.createStatement();
               out.println("<table border>");

               if (CONSULTA.equals("incidencies")) {
                   String query = "SELECT codiIncidencia, descripcio, producte, factura, ";
                   query +=       "       tipusIncidencia, dataObertura, dataTancament";
                   query +=       "  FROM incidencia";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   " WHERE codiIncidencia = '" + CODI + "'";
                       out.println("<Body><H1>Consulta incidncia per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula incidncies</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codiIncidencia</td>" +
                        "<td>descripcio</td>" +
                        "<td>producte</td>" +
                        "<td>factura</td>" +
                        "<td>tipusIncidencia</td>" +
                        "<td>dataObertura</td>" +
                        "<td>dataTancament</td>" +
                        "</tr>");

                   // Perform the query
                   ResultSet rs = statement.executeQuery(query);

                   // Iterate through each row of rs
                   while (rs.next()) {
                       String inc_codi = rs.getString("codiIncidencia");
                       String inc_desc = rs.getString("descripcio");
                       String inc_prod = rs.getString("producte");
                       String inc_fact = rs.getString("factura");
                       String inc_tInc = rs.getString("tipusIncidencia");
                       String inc_dtIn = rs.getString("dataObertura");
                       String inc_dtFi = rs.getString("dataTancament");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + inc_codi + "</td>" +
                            "<td>" + inc_desc + "</td>" +
                            "<td><A href=\"./Electrodomestics?consulta=productes" +
                                 "&codi=" + inc_prod + "\">" + inc_prod +
                                 "</A></td>" +
                            "<td>" + inc_fact + "</td>" +
                            "<td><A href=\"./Electrodomestics?consulta=tipus_inc" +
                                 "&codi=" + inc_tInc + "\">" + inc_tInc +
                                 "</A></td>" +
                            "<td>" + inc_dtIn + "</td>" +
                            "<td>" + inc_dtFi + "</td>" +
                            "</tr>");
                   }
               } else if (CONSULTA.equals("productes")) {
                   String query = "SELECT codiProducte, descripcio, tipus, ";
                   query +=       "       preuCost, preuVenda, duradaGarantia";
                   query +=       "  FROM producte";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   " WHERE codiProducte = '" + CODI + "'";
                       out.println("<Body><H1>Consulta producte per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula productes</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codiProducte</td>" +
                        "<td>descripcio</td>" +
                        "<td>tipus</td>" +
                        "<td>preuCost</td>" +
                        "<td>preuVenda</td>" +
                        "<td>duradaGarantia</td>" +
                        "</tr>");

                   ResultSet rs = statement.executeQuery(query);
                   while (rs.next()) {
                       String prd_codi = rs.getString("codiProducte");
                       String prd_desc = rs.getString("descripcio");
                       String prd_tipu = rs.getString("tipus");
                       String prd_pCst = rs.getString("preuCost");
                       String prd_pVnd = rs.getString("preuVenda");
                       String prd_dGar = rs.getString("duradaGarantia");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + prd_codi + "</td>" +
                            "<td>" + prd_desc + "</td>" +
                            "<td><A href=\"./Electrodomestics?consulta=tipus_prd" +
                                 "&codi=" + prd_tipu + "\">" + prd_tipu +
                                 "</A></td>" +
                            "<td>" + prd_pCst + "</td>" +
                            "<td>" + prd_pVnd + "</td>" +
                            "<td>" + prd_dGar + "</td>" +
                            "</tr>");
                   }
               } else if (CONSULTA.equals("accions")) {
                   String query = "SELECT codiAccio, incidencia, enginyer, ";
                   query +=       "       descripcio, dataInici, dataFi, cost";
                   query +=       "  FROM accio";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   " WHERE codiAccio = '" + CODI + "'";
                       out.println("<Body><H1>Consulta acci per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula accions</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codiAccio</td>" +
                        "<td>incidencia</td>" +
                        "<td>enginyer</td>" +
                        "<td>descripcio</td>" +
                        "<td>dataInici</td>" +
                        "<td>dataFi</td>" +
                        "<td>cost</td>" +
                        "</tr>");

                   ResultSet rs = statement.executeQuery(query);
                   while (rs.next()) {
                       String acc_codi = rs.getString("codiAccio");
                       String acc_inci = rs.getString("incidencia");
                       String acc_engy = rs.getString("enginyer");
                       String acc_desc = rs.getString("descripcio");
                       String acc_dIni = rs.getString("dataInici");
                       String acc_dtFi = rs.getString("dataFi");
                       String acc_cost = rs.getString("cost");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + acc_codi + "</td>" +
                            "<td><A href=\"./Electrodomestics?consulta=incidencies" +
                                 "&codi=" + acc_inci + "\">" + acc_inci +
                                 "</A></td>" +
                            "<td><A href=\"./Electrodomestics?consulta=enginyers" +
                                 "&codi=" + acc_engy + "\">" + acc_engy +
                                 "</A></td>" +
                            "<td>" + acc_desc + "</td>" +
                            "<td>" + acc_dIni + "</td>" +
                            "<td>" + acc_dtFi + "</td>" +
                            "<td>" + acc_cost + "</td>" +
                            "</tr>");
                   }
               } else if (CONSULTA.equals("tipus_prd")) {
                   String query = "SELECT codiTipusPrd, gamma, descripcio";
                   query +=       "  FROM tipus_prd";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   " WHERE codiTipusPrd = '" + CODI + "'";
                       out.println("<Body><H1>Consulta tipus de producte per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula tipus de producte</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codiTipusPrd</td>" +
                        "<td>gamma</td>" +
                        "<td>descripcio</td>" +
                        "</tr>");

                   ResultSet rs = statement.executeQuery(query);
                   while (rs.next()) {
                       String tip_prd_codi = rs.getString("codiTipusPrd");
                       String tip_prd_gamm = rs.getString("gamma");
                       String tip_prd_desc = rs.getString("descripcio");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + tip_prd_codi + "</td>" +
                            "<td><A href=\"./Electrodomestics?consulta=gamma" +
                                 "&codi=" + tip_prd_gamm + "\">" + tip_prd_gamm +
                                 "</A></td>" +
                            "<td>" + tip_prd_desc + "</td>" +
                            "</tr>");
                   }
               } else if (CONSULTA.equals("gamma")) {
                   String query = "SELECT codiGamma, descripcio";
                   query +=       "  FROM gamma";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   " WHERE codiGamma = '" + CODI + "'";
                       out.println("<Body><H1>Consulta gamma per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula de gammes</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codiGamma</td>" +
                        "<td>descripcio</td>" +
                        "</tr>");

                   ResultSet rs = statement.executeQuery(query);
                   while (rs.next()) {
                       String gamma_codi = rs.getString("codiGamma");
                       String gamma_desc = rs.getString("descripcio");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + gamma_codi + "</td>" +
                            "<td>" + gamma_desc + "</td>" +
                            "</tr>");
                   }
               } else if (CONSULTA.equals("tipus_inc")) {
                   String query = "SELECT codiTipusInc, descripcio, garantiaAplicable";
                   query +=       "  FROM tipus_inc";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   " WHERE codiTipusInc = '" + CODI + "'";
                       out.println("<Body><H1>Consulta tipus d'incidncia per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula tipus d'incidncia</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codiTipusInc</td>" +
                        "<td>descripcio</td>" +
                        "<td>garantiaAplicable</td>" +
                        "</tr>");

                   ResultSet rs = statement.executeQuery(query);
                   while (rs.next()) {
                       String tip_inc_codi = rs.getString("codiTipusInc");
                       String tip_inc_desc = rs.getString("descripcio");
                       String tip_inc_gapl = rs.getString("garantiaAplicable");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + tip_inc_codi + "</td>" +
                            "<td>" + tip_inc_desc + "</td>" +
                            "<td>" + tip_inc_gapl + "</td>" +
                            "</tr>");
                   }
               } else if (CONSULTA.equals("enginyers")) {
                   String query = "SELECT en.codiEmpleat as codi, em.nom as nom,";
                   query +=       "       en.especialitat as espe";
                   query +=       "  FROM enginyer en, empleat em";
                   query +=       " WHERE en.codiEmpleat = em.codiEmpleat";

                   String CODI = request.getParameter("codi");
                   if (CODI != null) {
                       query +=   "   AND en.codiEmpleat = '" + CODI + "'";
                       out.println("<Body><H1>Consulta enginyer per codi</H1>");
                   } else {
                       out.println("<Body><H1>Consulta taula dels enginyers</H1>");
                   }

                   out.println("<tr BGCOLOR=\"#BFFFBF\">" +
                        "<td>codi empleat</td>" +
                        "<td>nom</td>" +
                        "<td>especialitat</td>" +
                        "</tr>");

                   ResultSet rs = statement.executeQuery(query);
                   while (rs.next()) {
                       String eng_codi = rs.getString("codi");
                       String eng_nom  = rs.getString("nom");
                       String eng_espe = rs.getString("espe");
                       out.println("<tr BGCOLOR=\"#E6FFE6\">" +
                            "<td>" + eng_codi + "</td>" +
                            "<td>" + eng_nom  + "</td>" +
                            "<td>" + eng_espe + "</td>" +
                            "</tr>");
                   }
               } else {
                   out.println("Consulta '" + CONSULTA + "' no prevista");
               }

               out.println("</table><br><table border=0><tr>");
               out.println("<td><INPUT TYPE=\"button\" VALUE=\"Inici\" onClick=\"window.location.href='./MenuInici.html'\"></td>");
               out.println("<td></td>");
               out.println("<td><INPUT TYPE=\"button\" VALUE=\"Enrera\" onClick=\"history.go(-1);return true;\"></td>");
               out.println("</tr></table></body></html>");
               statement.close();
            } else {
               out.println("No s'ha indicat la consulta a fer. Utilitza el format URL?consulta=xxx");
            }

        } catch(Exception ex) {
            out.println("<HTML>" +
                        "<Head><Title>" +
                        "*** Error ***" +
                        "</Title></Head>\n<Body>" +
                        "<P>SQL error in doGet: " +
                        ex.getMessage() +
                        "</P></Body></HTML>");
            return;
        }
        out.close();
    }

    public void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        doGet(request, response);
    }
}
